const Stripe = require("stripe");
const dotenv = require("dotenv");

dotenv.config();

const Publishable_Key = process.env.PUB_KEY_STRIPE;
const Secret_Key = process.env.SECRET_KEY_STRIPE;

const stripe = Stripe(Secret_Key);

// CREATE A CUSTOMER WITH DATA FROM BODY ->  name, email, phone,desciption,
// POST /add-customer
const createCustomer = async (req, res) => {
  const { name, email, phone, description } = req.body;
  if (!name || !email || !phone || !description) {
    res.status(400).json({ message: "Invalid customer data" });
    return;
  }
  try {
    const customer = await stripe.customers.create({
      name,
      email,
      phone,
      description,
    });
    res.json({ customer });
  } catch (error) {
    res.status(error.statusCode).json({ message: error.raw.message });
  }
};

// GET /customer/:id
const findCustomerById = async (req, res) => {
  const id = req.params.id;
  try {
    const customer = await stripe.customers.retrieve(id);
    res.json({ customer });
  } catch (error) {
    res.status(error.statusCode).json({ message: error.raw.message });
  }
};

// add a payment card to a customer so he can proceed to paiement
// POST /add-card
const addCardToCustomer = async (req, res) => {
  const { cardNumber, expMonth, expYear, cardCVC, name, customerId } = req.body;
  if (!customerId) {
    res.status(400).json({ message: "Bad Request, no customer found" });
    return;
  }
  if (!cardNumber || !expMonth || !expYear || !cardCVC || !name) {
    res.status(400).json({ message: "Bad Request, no card data found" });
    return;
  }
  await stripe.tokens.create(
    {
      // Create the card
      card: {
        number: cardNumber,
        exp_month: expMonth,
        exp_year: expYear,
        cvc: cardCVC,
        name: name,
      },
    },
    function (err, token) {
      if (err) {
        // Error creating card token
        res.status(err.statusCode).json({ message: err.raw.message });
      } else {
        stripe.customers.update(
          // Set the customer ID
          customerId,
          // Set the source to the id of the token that was just created
          { source: token.id },
          function (err, card) {
            if (err) {
              // Error adding card to customer
              res.status(err.statusCode).json({ message: err.raw.message });
            } else {
              // Success
              res.json(card);
            }
          }
        );
      }
    }
  );
};

const paymentHandler = async (req, res) => {
  const { customerId, amount } = req.body;
  if (!customerId) {
    res.status(400).json({ message: "Bad Request, no customer found" });
    return;
  }
  if (!amount) {
    res.status(400).json({ message: "Bad Request, no amount found" });
    return;
  }
  stripe.charges.create(
    {
      // amout : 2000 -> 20Eur
      amount: amount,
      currency: "eur",
      customer: customerId,

      description: "Massa trails test paiement",
    },
    {
      /** An idempotency key is a unique value generated by the client which the server uses to recognize subsequent
       * retries of the same request. How you create unique keys is up to you, but we suggest using V4 UUIDs, or another
       * random string with enough entropy to avoid collisions. Idempotency keys can be up to 255 characters long. */
      idempotencyKey: Math.random().toString(),
    },
    function (err, charge) {
      if (err) {
        res.status(err.statusCode).json({ message: err.raw.message });
      }
      res.json({ charge });
    }
  );
};

// GET CHARGE BY ID
// GET /charge/:id

const getChargeById = async (req, res) => {
  const chargeId = req.params.id;
  if (!chargeId) {
    res.status(400).json({ message: "bad request, charge id invalid" });
    return;
  }
  try {
    var charge = await stripe.charges.retrieve(chargeId);

    res.json({ charge });
  } catch (error) {
    res.status(error.statusCode).json({ message: error.raw.message });
  }
};

// Subscribe a user
const subscribeCustomer = async (req, res) => {
  const { customerId, productId } = req.body;

  if (!productId) {
    res.status(404).json({ message: "product not found" });
    return;
  }
  if (!customerId) {
    res.status(404).json({ message: "customer not found" });
    return;
  }
  try {
    const subscription = await stripe.subscriptions.create({
      customer: customerId,
      items: [{ price: productId }],
    });
    res.json({ subscription });
  } catch (error) {
    res.status(error.statusCode).json({ message: error.raw.message });
  }
};

// Found Subscription by  id
const getSubsrciption = async (req, res) => {
  const { subscriptionId } = req.body;
  if (!subscriptionId) {
    res.status(400).json({ message: "bad request, subscription not found" });
    return;
  }
  try {
    const subscription = await stripe.subscriptions.retrieve(subscriptionId);
    res.json(subscription);
  } catch (error) {
    res.status(error.statusCode).json({ message: error.raw.message });
  }
};

// Unsubscribe
const unsubscribeCustomer = async (req, res) => {
  const { subscriptionId } = req.body;
  if (!subscriptionId) {
    res.status(400).json({ message: "bad request, subscription not found" });
    return;
  }
  try {
    const subscription = await stripe.subscriptions.del(subscriptionId);

    res.json({ subscription });
  } catch (error) {
    res.status(error.statusCode).json({ message: error.raw.message });
  }
};

module.exports = {
  getChargeById,
  paymentHandler,
  createCustomer,
  addCardToCustomer,
  findCustomerById,
  subscribeCustomer,
  getSubsrciption,
  unsubscribeCustomer,
};
